#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

typedef struct {
	int max;  //total size
	int n;    //used size
	int *M; //array
} arr_t;

int compare(const void *a, const void *b){
	int *aa = (int*)a;
	int *bb = (int*)b;
	return *aa - *bb;
}

int print(arr_t *a){
	a->M[a->n] = a->M[a->n - 1] -1; // we add an element at the end to differentiate from the last
	int count = 0;
	for(int i = 0; i < a->n; i++)
		if(a->M[i] != a->M[i + 1]){
			count++;
			//printf("%d: %d\n", count, a->M[i]);
		}
	return count;
}


int main(void){
	int n;
	printf("How many: ");
	if(scanf("%d", &n) < 1 || n < 1)
		return 0;
	printf("----------------------------------------\n\n");
	arr_t arr = {n, n, malloc((n + 1) * sizeof(*arr.M))}; 
	if(arr.M == NULL){
		printf("Could not allocate memory.\n");
		return 0;
	}	
	int k = n * 2;
	struct timeval start, stop;
	gettimeofday(&start, NULL);
	// v // mdame seda osa  let's measure this part
	for(int i = 0; i < n; i++)
		arr.M[i] = rand() % k;
	qsort(arr.M, arr.n, sizeof(*arr.M),compare);
	int unique = print(&arr);
	// ^ // mdame seda osa  let's measure this part
	gettimeofday(&stop, NULL);
	double sec = stop.tv_sec + (stop.tv_usec / 1000000.0) - 
		( start.tv_sec + start.tv_usec / 1000000.0);
	printf("Time\t%12.6f\n", sec);			
	printf("Unique: %d\n", unique);

	return 0;
}
